
/*****************************************************************************
 * gcrLib : Graphics Rocchini's Library V0.9 (the nth OpenGL wrapper)        *
 *					                                                         *
 * Copyright(C) 1999 by Claudio Rocchini. All rights reserved.               *
 *					                                                         *
 * Permission  to use, copy, modify, distribute  and sell this  software and *
 * its documentation for any purpose is hereby granted without fee, provided *
 * that  the above copyright notice appear  in all copies and that both that *
 * copyright   notice  and  this  permission  notice  appear  in  supporting *
 * documentation. the author makes  no representations about the suitability *
 * of this software for any purpose. It is provided  "as is" without express *
 * or implied warranty.                                                      *
 *					                                                         *
 *****************************************************************************/

#pragma warning( disable : 4804 )
#pragma warning( once : 4201 4663 )

#include <windows.h>
#include <gl/gl.h>
#include <gl/glu.h>
#include <assert.h>
#include <algorithm>


#include "algo.h"
#include "primitive.h"



	// Generazione di normali
/*
class VFAssoc
{
public:
	inline VFAssoc() {}

	inline VFAssoc( const int nv, const int nf, const int nq )
	{
		v = nv;
		f = nf;
		q = nq;
	}

	inline bool operator == ( const VFAssoc & vfa ) const
	{
		return v==vfa.v && f==vfa.f && q==vfa.q;
	}

	inline bool operator <  ( const VFAssoc & vfa ) const
	{
		return v<vfa.v;
	}

	int v;		// Vertice
	int f;		// Faccia
	int q;		// Indice dello spigolo
};
*/

#if 0
	// Vero se due facce sono adiacenti	(due vertici in comune)
inline bool fadj( grTriangles & v, int a, int b )
{
	int i,j,n;

	n = 0;
	for(i=0;i<3;i++)
		for(j=0;j<3;j++)
			if(v[a+i]==v[b+j])
			{
				++n;
				break;
			}
	return n==2;
}
#endif


void grGenNormal( const grVertex3f & vert, const grTriangles & prim, double cangle,
				  grNormalBinding & nbind, grNormalf & norm )
{
	int i,j;

	double rad = acos(cangle * 3.14159265359 / 180);

	if(cangle==0.0)			// Caso speciale 1: nessuna interpolazione
	{
		nbind.value = grNormalBinding::PER_FACE;
		int n = prim.size()/3;
		norm.resize(n);
		for(i=0;i<n;i++)
			norm[i] = (vert[prim[i*3+1]] - vert[prim[i*3+0]]) ^
					  (vert[prim[i*3+2]] - vert[prim[i*3+0]]) ;
	}
	else if(cangle>=180)	// Caso speciale 2: interpolazione totale
	{
		nbind.value = grNormalBinding::PER_VERTEX;
		norm.resize(vert.size());

		for(i=0;i<int(vert.size());i++)
			norm[i].Set(0,0,0);

		for(i=0;i<int(prim.size()/3);i++)
		{

			Coord3f t = (vert[prim[i*3+1]] - vert[prim[i*3+0]]) ^
			            (vert[prim[i*3+2]] - vert[prim[i*3+0]]) ;
			for(j=0;j<3;j++)
				norm[prim[i*3+j]] += t;
		}
	}
	else					// Interpolazione intermedia
	{
#if 0
		nbind.value = grNormalBinding::PER_CORNER;
		norm.resize(prim.size());

			// Ad ogni spigolo viene assegnata la normale della faccia
			// incidente (come in interpolazione zero).
		for(i=0;i<prim.size()/3;i++)
		{

			Coord3f t = (vert[prim[i*3+1]] - vert[prim[i*3+0]]) ^
			            (vert[prim[i*3+2]] - vert[prim[i*3+0]]) ;
			t.Normalize();
			for(j=0;j<3;j++)
				norm[i*3+j] = t;
		}

			// Generazione insieme coppie vertice-faccia adiacente
		vector< VFAssoc > vfset(prim.size());
		for(i=0;i<prim.size();i++)
			vfset[i] = VFAssoc(prim[i],i/3,i);

			// Ordinamento per vertice
		sort(vfset.begin(),vfset.end());

FILE *fp = fopen("result.txt","wb");

			// Scansione singoli vertici
		for(i=0;i<prim.size();)
		{
				// Ricerca fine blocco vertice [i,j)
			j=i+1;
			while(j<prim.size() && vfset[j].v==vfset[i].v)
				++j;

fprintf(fp,"%d %d\n",vfset[i].v,j-i);

				// Riordinamento delle facce intorno al vertice
				// Raggruppamento di blocchi [k,h)
			for(int k=i;k<j;)
			{
				int h=k+1;

				int q,w;
				for(q=k;q<h;q++)
					for(w=h;w<j;w++)
						if( fadj(prim,vfset[q].f,vfset[w].f) )
						{
							double a = norm[vfset[q].q] * norm[vfset[w].q];
                            if(a<rad)
							{
								fa finbire
							}
						}

					// Prossimo segmento vertice
				k = h;
			}

				// Prossimo blocco vertice
			i = j;
		}

fclose(fp);
#endif
	}

	for(i=0;i<int(vert.size());i++)		// Normalizzazione finale
		norm[i].Normalize();
}


void grViewAll( const grVertex3f & vert, grScalef & scale, grTranslationf & trans )
{
	Coord3f mi,ma;

	mi = ma = vert[0];

	for(int i=0;i<int(vert.size());i++)
		for(int j=0;j<3;j++)
		{
			if(mi[j]>vert[i][j]) mi[j] = vert[i][j];
			if(ma[j]<vert[i][j]) ma[j] = vert[i][j];
		}
	Coord3f me = mi+ma;
	Coord3f t = -(me/2);
	trans.x = t.x;
	trans.y = t.y;
	trans.z = t.z;
	me = mi-ma;
	float s = 10/Norm(me);
	scale.x = s;
	scale.y = s;
	scale.z = s;
}


void grViewAll( const Boxd & b, grScalef & scale, grTranslationf & trans )
{
	Coord3d t = -(b.min+b.max)*0.5;
	trans.x = float(t.x);
	trans.y = float(t.y);
	trans.z = float(t.z);
	float s = float(10/b.Diag());
	scale.x = s;
	scale.y = s;
	scale.z = s;
}


void grViewAll( const Boxf & b, grScalef & scale, grTranslationf & trans )
{
	Coord3f t = -(b.min+b.max)*0.5;
	trans.x = t.x;
	trans.y = t.y;
	trans.z = t.z;
	float s = 10/b.Diag();
	scale.x = s;
	scale.y = s;
	scale.z = s;
}

#pragma warning( default : 4201 4663 )