
/*****************************************************************************
 * gcrLib : Graphics Rocchini's Library V0.9 (the nth OpenGL wrapper)        *
 *					                                                         *
 * Copyright(C) 1999 by Claudio Rocchini. All rights reserved.               *
 *					                                                         *
 * Permission  to use, copy, modify, distribute  and sell this  software and *
 * its documentation for any purpose is hereby granted without fee, provided *
 * that  the above copyright notice appear  in all copies and that both that *
 * copyright   notice  and  this  permission  notice  appear  in  supporting *
 * documentation. the author makes  no representations about the suitability *
 * of this software for any purpose. It is provided  "as is" without express *
 * or implied warranty.                                                      *
 *					                                                         *
 *****************************************************************************/


#ifndef GR_SHQN_BASE
#define GR_SHQN_BASE


/** @name glwrapper
	@memo C++ wrapper for opengl functions.
	@see opengl
 */


//@{

/** @name glColor Wrapper
 */

//@{

	/// wrapper for glcolor (3 GLbyte params)
inline void glColor( const GLbyte red, const GLbyte green, const GLbyte blue )
{
	glColor3b(red,green,blue);
}

	/// wrapper for glcolor (3 GLdouble params)
inline void glColor( const GLdouble red, const GLdouble green, const GLdouble blue )
{ 	
	glColor3d(red,green,blue);
}
 
	/// wrapper for glcolor (3 GLfloat params)
inline void glColor( const GLfloat red, const GLfloat green, const GLfloat blue )
{
	glColor3f(red,green,blue);
}

	/// wrapper for glcolor (3 GLint params)
inline void glColor( const GLint red, const GLint green, const GLint blue )
{
	glColor3i(red,green,blue);
}

 	/// wrapper for glcolor (3 GLshort params)
inline void glColor( const GLshort red, const GLshort green, const GLshort blue )
{
	glColor3s(red,green,blue);
}

  	/// wrapper for glcolor (3 GLubyte params)
inline void glColor( const GLubyte red, const GLubyte green, const GLubyte blue )
{
	glColor3ub(red,green,blue);
}

   	/// wrapper for glcolor (3 GLuint params)
inline void glColor( const GLuint red, const GLuint green, const GLuint blue )
{
	glColor3ui(red,green,blue);
}

    	/// wrapper for glcolor (3 GLushort params)
inline void glColor( const GLushort red, const GLushort green, const GLushort blue )
{
	glColor3us(red,green,blue);
}

    	/// wrapper for glcolor (4 GLbyte params)
inline void glColor( const GLbyte red, const GLbyte green, const GLbyte blue, const GLbyte alpha )
{
	glColor4b(red,green,blue,alpha);
}

    	/// wrapper for glcolor (4 GLdouble params) 
inline void glColor( const GLdouble red, const GLdouble green, const GLdouble blue, const GLdouble alpha )
{
	glColor4d(red,green,blue,alpha);
}

    	/// wrapper for glcolor (4 GLfloat params) 
inline void glColor( const GLfloat red, const GLfloat green, const GLfloat blue, const GLfloat alpha )
{
	glColor4f(red,green,blue,alpha);
}

    	/// wrapper for glcolor (4 GLint params) 
inline void glColor( const GLint red, const GLint green, const GLint blue, const GLint alpha )
{
	glColor4i(red,green,blue,alpha);
}

    	/// wrapper for glcolor (4 GLshort params) 
inline void glColor( const GLshort red, const GLshort green, const GLshort blue, const GLshort alpha )
{
	glColor4s(red,green,blue,alpha);
}

    	/// wrapper for glcolor (4 GLubyte params) 
inline void glColor( const GLubyte red, const GLubyte green, const GLubyte blue, const GLubyte alpha )
{
	glColor4ub(red,green,blue,alpha);
}

    	/// wrapper for glcolor (4 GLuint params)  
inline void glColor( const GLuint red, const GLuint green, const GLuint blue, const GLuint alpha )
{
	glColor4ui(red,green,blue,alpha);
}

    	/// wrapper for glcolor (4 GLushort params)  
inline void glColor( const GLushort red, const GLushort green, const GLushort blue, const GLushort alpha )
{
	glColor4us(red,green,blue,alpha);
}

    	/// wrapper for glcolor (3 GLbyte pointer)
inline void glColor( const GLbyte * const v )
{
	glColor3bv(v);
}

    	/// wrapper for glcolor (3 GLdouble pointer) 
inline void glColor( const GLdouble * const v )
{
	glColor3dv(v);
}

    	/// wrapper for glcolor (3 GLfloat pointer) 
inline void glColor3( const GLfloat * const v )
{
	glColor3fv(v);
}

    	/// wrapper for glcolor (3 GLint pointer) 
inline void glColor3( const GLint * const v )
{
	glColor3iv(v);
}

    	/// wrapper for glcolor (3 GLshort pointer) 
inline void glColor3( const GLshort * const v )
{
	glColor3sv(v);
}

    	/// wrapper for glcolor (3 GLubyte pointer)
inline void glColor3( const GLubyte * const v )
{
	glColor3ubv(v);
}

    	/// wrapper for glcolor (3 GLuint pointer) 
inline void glColor3( const GLuint * const v )
{
	glColor3uiv(v);
}

    	/// wrapper for glcolor (3 GLushort pointer) 
inline void glColor3( const GLushort * const v )
{
	glColor3usv(v);
}

    	/// wrapper for glcolor (4 GLbyte pointer)
inline void glColor4( const GLbyte * const v )
{
	glColor4bv(v);
}

    	/// wrapper for glcolor (4 GLdouble pointer) 
inline void glColor4( const GLdouble * const v )
{
	glColor4dv(v);
}

    	/// wrapper for glcolor (4 GLfloat pointer) 
inline void glColor4( const GLfloat * const v )
{
	glColor4fv(v);
}

    	/// wrapper for glcolor (4 GLint pointer) 
inline void glColor4( const GLint * const v )
{
	glColor4iv(v);
}

    	/// wrapper for glcolor (4 GLshort pointer) 
inline void glColor4( const GLshort * const v )
{
	glColor4sv(v);
}

    	/// wrapper for glcolor (4 GLubyte pointer) 
inline void glColor4( const GLubyte * const v )
{
	glColor4ubv(v);
}
 
    	/// wrapper for glcolor (4 GLuint pointer)
inline void glColor4( const GLuint * const v )
{
	glColor4uiv(v);
}

    	/// wrapper for glcolor (4 GLushort pointer) 
inline void glColor4( const GLushort * const v )
{
	glColor4usv(v);	
} 

//@}

/** @name glEvalCoord Wrapper
 */

//@{

    	/// wrapper for glEvalCoord 1 dimension (GLdouble) 
inline void glEvalCoord( const GLdouble u )
{
	glEvalCoord1d(u);
}

    	/// wrapper for glEvalCoord 1 dimension (GLfloat)  
inline void glEvalCoord( const GLfloat u )
{
	glEvalCoord1f(u);
}

    	/// wrapper for glEvalCoord 2 dimensions (GLdouble)  
inline void glEvalCoord( const GLdouble u, const GLdouble v )
{
	glEvalCoord2d(u,v);
}

    	/// wrapper for glEvalCoord 2 dimension (GLfloat)  
inline void glEvalCoord( const GLfloat u, const GLfloat v )
{
	glEvalCoord2f(u,v);
}

    	/// wrapper for glEvalCoord 1 dimension (GLdouble pointer)   
inline void glEvalCoord1( const GLdouble * const u )
{
	glEvalCoord1dv(u);
}

    	/// wrapper for glEvalCoord 1 dimension (GLfloat pointer)  
inline void glEvalCoord1( const GLfloat * const u )
{
	glEvalCoord1fv(u);
}

    	/// wrapper for glEvalCoord 2 dimensions (GLdouble pointer)  
inline void glEvalCoord2( const GLdouble * const u )
{
	glEvalCoord2dv(u);
}

    	/// wrapper for glEvalCoord 2 dimensions (GLfloat pointer)  
inline void glEvalCoord2( const GLfloat * const u )
{
	glEvalCoord2fv(u);
}

//@}

/** @name glEvalMesh Wrapper
 */

//@{

	/// wrapper for glEvalMesh 1 dimension
inline void glEvalMesh( const GLenum mode, const GLint i1, const GLint i2 )
{
	glEvalMesh1(mode,i1,i2);
}

	/// wrapper for glEvalMesh 2 dimensions
inline void glEvalMesh( const GLenum mode, const GLint i1, const GLint i2, const GLint j1, const GLint j2 )
{
	glEvalMesh2(mode,i1,i2,j1,j2);
}

//@}

/** @name glEvalMesh Wrapper
 */

//@{

	/// wrapper for glEvalPoint 1 dimension
inline void glEvalPoint( const GLint i )
{
	glEvalPoint1(i);
}

	/// wrapper for glEvalPoint 2 dimensions
inline void glEvalPoint( const GLint i, const GLint j )
{
	glEvalPoint2(i,j);
}

//@}

/** @name glFog Wrapper
 */

//@{

	/// wrapper for glFog (float param)
inline void glFog(  const GLenum pname, const GLfloat param )
{
	glFogf(pname,param);
}

	/// wrapper for glFog (int param)
inline void glFog( const GLenum pname, const GLint param )
{
	glFogi(pname,param);
}

	/// wrapper for glFog (float params)
inline void glFog( const GLenum pname, const GLfloat * const params )
{
	glFogfv(pname,params);
}

	/// wrapper for glFog (int params)
inline void glFog( const GLenum pname, const GLint * const params )
{
	glFogiv(pname,params);
}

//@}

/** @name glGet Wrapper
 */

//@{

	/// wrapper for glGet (GLboolean pointer params)
inline void glGet( const GLenum pname, GLboolean * const params )
{
	glGetBooleanv(pname,params);
}

	/// wrapper for glGet (GLdouble pointer params) 
inline void glGet( const GLenum pname, GLdouble * const params )
{
	glGetDoublev(pname,params);
}

	/// wrapper for glGet (GLfloat pointer params)
inline void glGet( const GLenum pname, GLfloat * const params )
{
	glGetFloatv(pname,params);
}

	/// wrapper for glGet (GLint pointer params)
inline void glGet( const GLenum pname, GLint * const params )
{
	glGetIntegerv(pname,params);
}

//@}

/** @name glGetLight Wrapper
 */

//@{

	/// wrapper for glGetLight (float params)
inline void glGetLight( const GLenum light, const GLenum pname, GLfloat * const params )
{
	glGetLightfv(light,pname,params);
}

	/// wrapper for glGetLight (int params) 
inline void glGetLight( const GLenum light, const GLenum pname, GLint * const params )
{
	glGetLightiv(light,pname,params);
}

//@}

/** @name glGetMap Wrapper
 */

//@{

	/// wrapper fr glGetMap (double params)
inline void glGetMap( const GLenum target, const GLenum query, GLdouble * const v )
{
	glGetMapdv(target,query,v);
}

	/// wrapper fr glGetMap (float params)
inline void glGetMap( const GLenum target, const GLenum query, GLfloat * const v )
{
	glGetMapfv(target,query,v);
}

	/// wrapper fr glGetMap (int params)
inline void glGetMap( const GLenum target, const GLenum query, GLint * const v )
{
	glGetMapiv(target,query,v);
}

//@}

/** @name glGetMaterial Wrapper
 */

//@{

	/// wrapper for glGetMaterial (float params)
inline void glGetMaterial( const GLenum face, const GLenum pname, GLfloat * const params )
{
	glGetMaterialfv(face,pname,params);
}

	/// wrapper for glGetMaterial (int params)
inline void glGetMaterial( const GLenum face, const GLenum pname, GLint * const params )
{
	glGetMaterialiv(face,pname,params);
}

//@}

/** @name glGetPixelMap Wrapper
 */

//@{

	/// wrapper for glGetPixelMap (float params)
inline void glGetPixelMap( const GLenum map, GLfloat * const values )
{
	glGetPixelMapfv(map,values);
}

	/// wrapper for glGetPixelMap (uint params)
inline void glGetPixelMap( const GLenum map, GLuint * const values )
{
	glGetPixelMapuiv(map,values);
}

	/// wrapper for glGetPixelMap (ushort params)
inline void glGetPixelMap( const GLenum map, GLushort * const values )
{
	glGetPixelMapusv(map,values);
}

//@}

/** @name glGetTexEnv Wrapper
 */

//@{

	/// wrapper for glGetTexEnv (float params)
inline void glGetTexEnv( const GLenum target, const GLenum pname, GLfloat * const params )
{
	glGetTexEnvfv(target,pname,params);
}

	/// wrapper for glGetTexEnv (int params)
inline void glGetTexEnv( const GLenum target, const GLenum pname, GLint * const params )
{
	glGetTexEnviv(target,pname,params);
}

//@}

/** @name glGetTexGen Wrapper
 */

//@{

	/// wrapper for glGetTexGen (double param) 
inline void glGetTexGen( const GLenum coord, const GLenum pname, GLdouble * const params )
{
	glGetTexGendv(coord,pname,params);
}

	/// wrapper for glGetTexGen (float param)
inline void glGetTexGen( const GLenum coord, const GLenum pname, GLfloat * const params )
{
	glGetTexGenfv(coord,pname,params);
}

	/// wrapper for glGetTexGen (int param)
inline void glGetTexGen( const GLenum coord, const GLenum pname, GLint * const params )
{
	glGetTexGeniv(coord,pname,params);
}

//@}

/** @name glGetTexLevelParameter Wrapper
 */

//@{

	/// wrapper for glGetTexLevelParameter (float)
inline void glGetTexLevelParameter( const GLenum target, const GLint level, const GLenum pname, GLfloat * const params )
{
	glGetTexLevelParameterfv(target,level,pname,params);
}

	/// wrapper for glGetTexLevelParameter (int) 
inline void glGetTexLevelParameter( const GLenum target, const GLint level, const GLenum pname, GLint * const params )
{
	glGetTexLevelParameteriv(target,level,pname,params);
}

//@}

/** @name glGetTexParameter Wrapper
 */

//@{

	/// wrapper for glGetTexParameter (float)
inline void glGetTexParameter( const GLenum target, const GLenum pname, GLfloat * const params )
{
	glGetTexParameterfv(target,pname,params);
}

	/// wrapper for glGetTexParameter (int)
inline void glGetTexParameter( const GLenum target, const GLenum pname, GLint * const params )
{
	glGetTexParameteriv(target,pname,params);
}

//@}

/** @name glIndex Wrapper
 */

//@{

	/// wrapper for glIndex (double)
inline void glIndex( const GLdouble c )
{
	glIndexd(c);
}

	/// wrapper for glIndex (float)
inline void glIndex( const GLfloat c )
{
	glIndexf(c);
}

	/// wrapper for glIndex (int)
inline void glIndex( const GLint c )
{
	glIndexi(c);
}

	/// wrapper for glIndex (short)
inline void glIndex( const GLshort c )
{
	glIndexs(c);
}

	/// wrapper for glIndex (double pointer)
inline void glIndex( const GLdouble * const c )
{
	glIndexdv(c);
}

	/// wrapper for glIndex (float pointer)
inline void glIndex( const GLfloat * const c )
{
	glIndexfv(c);
}

	/// wrapper for glIndex (int pointer)
inline void glIndex( const GLint * const c )
{
	glIndexiv(c);
}

	/// wrapper for glIndex (short pointer)
inline void glIndex( const GLshort * const c )
{
	glIndexsv(c);
}

//@}

/** @name glLight Wrapper
 */

//@{

	/// wrapper for glLight (float)
inline void glLight( const GLenum light, const GLenum pname, const GLfloat param )
{
	glLightf(light,pname,param);
}

	/// wrapper for glLight (int)
inline void glLight( const GLenum light, const GLenum pname, const GLint param )
{
	glLighti(light,pname,param);
}

	/// wrapper for glLight (float pointer)
inline void glLight( const GLenum light, const GLenum pname, const GLfloat * const params )
{
	glLightfv(light,pname,params);
}

	/// wrapper for glLight (int pointer)
inline void glLight( const GLenum light, const GLenum pname, const GLint * const params )
{
	glLightiv(light,pname,params);
}

//@}

/** @name glLightModel Wrapper
 */

//@{

	/// wrapper for glLightModel (float)
inline void glLightModel( const GLenum pname, const GLfloat param )
{
   glLightModelf(pname,param);
}

	/// wrapper for glLightModel (int) 
inline void glLightModel( const GLenum pname, const GLint param )
{
   glLightModeli(pname,param);
}

	/// wrapper for glLightModel (float pointer)
inline void glLightModel( const GLenum pname, const GLfloat * const params )
{
   glLightModelfv(pname,params);
}

	/// wrapper for glLightModel (int pointer) 
inline void glLightModel( const GLenum pname, const GLint * const params )
{
   glLightModeliv(pname,params);
}

//@}

/** @name glLoadMatrix Wrapper
 */

//@{

	/// wrapper for glLoadMatrix (double)
inline void glLoadMatrix( const GLdouble *m )
{
	glLoadMatrixd(m);
}

	/// wrapper for glLoadMatrix (float)
inline void glLoadMatrix( const GLfloat *m )
{
	glLoadMatrixf(m);
}

//@}

/** @name glMap Wrapper
 */

//@{

	/// wrapper for glMap 1 dimension (double)
inline void glMap(
    const GLenum target, 	
    const GLdouble u1, 	
	const GLdouble u2, 	
    const GLint stride, 	
    const GLint order, 	
    const GLdouble * const points )
{
   glMap1d(target,u1,u2,stride,order,points);
}

	/// wrapper for glMap 1 dimension (float)
inline void glMap(
    const GLenum target, 	
    const GLfloat u1, 	
    const GLfloat u2, 	
    const GLint stride, 	
    const GLint order, 	
    const GLfloat * const points )
{
	glMap1f(target,u1,u2,stride,order,points);
}

	/// wrapper for glMap 2 dimensions (double)
inline void glMap(
    const GLenum target, 	
    const GLdouble u1, 	
    const GLdouble u2, 	
    const GLint ustride, 	
    const GLint uorder, 	
    const GLdouble v1, 	
    const GLdouble v2, 	
    const GLint vstride, 	
    const GLint vorder, 	
    const GLdouble * const points )
{
	glMap2d(target,u1,u2,ustride,uorder,v1,v2,vstride,vorder,points);
}

	/// wrapper for glMap 2 dimensions (float) 
inline void glMap(
    const GLenum target, 	
    const GLfloat u1, 	
    const GLfloat u2, 	
    const GLint ustride, 	
    const GLint uorder, 	
    const GLfloat v1, 	
    const GLfloat v2, 	
    const GLint vstride, 	
    const GLint vorder, 	
    const GLfloat * const points )
{
	glMap2f(target,u1,u2,ustride,uorder,v1,v2,vstride,vorder,points);
}

//@}

/** @name glMapGrid Wrapper
 */

//@{

	/// wrapper for glMapGrid 1 dimension (double)
inline void glMapGrid( const GLint un, const GLdouble u1, const GLdouble u2 )
{
   glMapGrid1d(un,u1,u2);
}

	/// wrapper for glMapGrid 1 dimension (float)
inline void glMapGrid( const GLint un, const GLfloat u1, const GLfloat u2 )
{
	glMapGrid1f(un,u1,u2);
}

	/// wrapper for glMapGrid 2 dimensions (double)
inline void glMapGrid( const GLint un, const GLdouble u1, const GLdouble u2, 	
					   const GLint vn, const GLdouble v1, const GLdouble v2 )
{
	glMapGrid2d(un,u1,u2,vn,v1,v2);
}

	/// wrapper for glMapGrid 2 dimensions (float)
inline void glMapGrid( const GLint un, const GLfloat u1, const GLfloat u2,
					   const GLint vn, const GLfloat v1, const GLfloat v2 )
{
	glMapGrid2f(un,u1,u2,vn,v1,v2);
}

//@}

/** @name glMaterial Wrapper
 */

//@{

	/// wrapper for glMaterial (float)
inline void glMaterial( const GLenum face, const GLenum pname, const GLfloat param )
{
	glMaterialf(face,pname,param);
}

	/// wrapper for glMaterial (int)
inline void glMaterial( const GLenum face, const GLenum pname, const GLint param )
{
	glMateriali(face,pname,param);
}

 	/// wrapper for glMaterial (float pointer)
inline void glMaterial( const GLenum face, const GLenum pname, const GLfloat * const params )
{
	glMaterialfv(face,pname,params);
}

	/// wrapper for glMaterial (int pointer)
inline void glMaterial( const GLenum face, const GLenum pname, const GLint * const params )
{
	glMaterialiv(face,pname,params);
}

//@}

	// ********************************* glMultMatrix

inline void glMultMatrix( const GLdouble * const m )
{
	glMultMatrixd(m);
}

 
inline void glMultMatrix( const GLfloat * const m )
{
	glMultMatrixf(m);
}

	// ********************************* glNormal

inline void glNormal( const GLbyte nx, const GLbyte ny, const GLbyte nz )
{
	glNormal3b(nx,ny,nz);
}

 
inline void glNormal( const GLdouble nx, const GLdouble ny, const GLdouble nz )
{
	glNormal3d(nx,ny,nz);
}

 
inline void glNormal( const GLfloat nx, const GLfloat ny, const GLfloat nz )
{
	glNormal3f(nx,ny,nz);
}

 
inline void glNormal( const GLint nx, const GLint ny, const GLint nz )
{
	glNormal3i(nx,ny,nz);
}

 
inline void glNormal( const GLshort nx, const GLshort ny, const GLshort nz )
{
	glNormal3s(nx,ny,nz);
}
 

inline void glNormal( const GLbyte * const v )
{
	glNormal3bv(v);
}

 
inline void glNormal( const GLdouble * const v )
{
	glNormal3dv(v);
}

 
inline void glNormal( const GLfloat * const v )
{
	glNormal3fv(v);
}

 
inline void glNormal( const GLint * const v )
{
	glNormal3iv(v);
}

 
inline void glNormal( const GLshort * const v )
{
	glNormal3sv(v);
}
	// ********************************* glPixelMap

inline void glPixelMap( const GLenum map, const GLint mapsize, const GLfloat * const values )
{
	glPixelMapfv(map,mapsize,values);
}

 
inline void glPixelMap( const GLenum map, const GLint mapsize, const GLuint * const values )
{
	glPixelMapuiv(map,mapsize,values);
}

 
inline void glPixelMap( const GLenum map, const GLint mapsize, const GLushort * const values )
{
	glPixelMapusv(map,mapsize,values);
}

	// ********************************* glPixelStore

inline void glPixelStore( const GLenum pname, const GLfloat param )
{
	glPixelStoref(pname,param);
}
 
inline void glPixelStore( const GLenum pname, const GLint param )
{
	glPixelStorei(pname,param);
}

	// ********************************* glPixelTransfer

inline void glPixelTransfer( const GLenum pname, const GLfloat param )
{
	glPixelTransferf(pname,param);
}

 
inline void glPixelTransfer( const GLenum pname, const GLint param )
{
	glPixelTransferi(pname,param);
}

	// ********************************* glRasterPos

inline void glRasterPos( const GLdouble x, const GLdouble y )
{	
	glRasterPos2d(x,y);
}


inline void glRasterPos( const GLfloat x, const GLfloat y )
{
	glRasterPos2f(x,y);
}
	
 
inline void glRasterPos( const GLint x, const GLint y )
{
	glRasterPos2i(x,y);
}

 
inline void glRasterPos( const GLshort x, const GLshort y )
{
	glRasterPos2s(x,y);
}

 
inline void glRasterPos( const GLdouble x, const GLdouble y, const GLdouble z )
{
	glRasterPos3d(x,y,z);
}

 
inline void glRasterPos( const GLfloat x, const GLfloat y, const GLfloat z )
{
	glRasterPos3f(x,y,z);
}

 
inline void glRasterPos( const GLint x, const GLint y, const GLint z )
{
	glRasterPos3i(x,y,z);
}

 
inline void glRasterPos( const GLshort x, const GLshort y, const GLshort z )
{
	glRasterPos3s(x,y,z);
}

  
inline void glRasterPos( const GLdouble x, const GLdouble y, const GLdouble z, const GLdouble w )
{
	glRasterPos4d(x,y,z,w);
}

 
inline void glRasterPos( const GLfloat x, const GLfloat y, const GLfloat z, const GLfloat w )
{
	glRasterPos4f(x,y,z,w);
}

 
inline void glRasterPos( const GLint x, const GLint y, const GLint z, const GLint w )
{
	glRasterPos4i(x,y,z,w);
}

 
inline void glRasterPos( const GLshort x, const GLshort y, const GLshort z, const GLshort w )
{
	glRasterPos4s(x,y,z,w);
}

 
inline void glRasterPos2( const GLdouble * const v )
{
	glRasterPos2dv(v);
}

 
inline void glRasterPos2( const GLfloat * const v )
{
	glRasterPos2fv(v);
}

 
inline void glRasterPos2( const GLint * const v )
{
	glRasterPos2iv(v);
}

 
inline void glRasterPos2( const GLshort * const v )
{
	glRasterPos2sv(v);
}

 
inline void glRasterPos3( const GLdouble * const v )
{
	glRasterPos3dv(v);
}

 
inline void glRasterPos3( const GLfloat * const v )
{
	glRasterPos3fv(v);
}

 
inline void glRasterPos3( const GLint * const v )
{
	glRasterPos3iv(v);
}

 
inline void glRasterPos3( const GLshort * const v )
{
	glRasterPos3sv(v);
}

 
inline void glRasterPos4( const GLdouble * const v )
{
	glRasterPos4dv(v);
}

 
inline void glRasterPos4( const GLfloat * const v )
{
	glRasterPos4fv(v);
}

 
inline void glRasterPos4( const GLint * const v )
{
	glRasterPos4iv(v);
}

 
inline void glRasterPos4( const GLshort * const v )
{
	glRasterPos4sv(v);
}

	// ********************************* glRect

inline void glRect( const GLdouble x1, const GLdouble y1, const GLdouble x2, const GLdouble y2 )
{
	glRectd(x1,y1,x2,y2);
}

 
inline void glRect( const GLfloat x1, const GLfloat y1, const GLfloat x2, const GLfloat y2 )
{
	glRectf(x1,y1,x2,y2);
}

 
inline void glRect( const GLint x1, const GLint y1, const GLint x2, const GLint y2 )
{
	glRecti(x1,y1,x2,y2);
}

 
inline void glRect( const GLshort x1, const GLshort y1, const GLshort x2, const GLshort y2 )
{
	glRects(x1,y1,x2,y2);
}

 
inline void glRect( const GLdouble * const v1, const GLdouble * const v2 )
{
	glRectdv(v1,v2);
}

 
inline void glRect( const GLfloat * const v1, const GLfloat * const v2 )
{
	glRectfv(v1,v2);
}

 
inline void glRect( const GLint * const v1, const GLint * const v2 )
{
	glRectiv(v1,v2);
}

 
inline void glRect( const GLshort * const v1, const GLshort * const v2 )
{
	glRectsv(v1,v2);
}

	// ********************************* glRotate

inline void glRotate( const GLdouble angle, const GLdouble x, const GLdouble y, const GLdouble z )
{
	glRotated(angle,x,y,z);
}

 
inline void glRotate( const GLfloat angle, const GLfloat x, const GLfloat y, const GLfloat z )
{
	glRotatef(angle,x,y,z);
}

	// ********************************* glScale

inline void glScale( const GLdouble x, const GLdouble y, const GLdouble z )
{
	glScaled(x,y,z);
}

 
inline void glScale( const GLfloat x, const GLfloat y, const GLfloat z )
{
	glScalef(x,y,z);
}

/** @name glTexCoord Wrapper
 */

//@{

	/// wrapper for glTexCoord 1 dimension (double)
inline void glTexCoord( const GLdouble s )
{
	glTexCoord1d(s);
}

	/// wrapper for glTexCoord 1 dimension (float)
inline void glTexCoord( const GLfloat s )
{
	glTexCoord1f(s);
}

	/// wrapper for glTexCoord 1 dimension (int)
inline void glTexCoord( const GLint s )
{
	glTexCoord1i(s);
}

	/// wrapper for glTexCoord 1 dimension (short)
inline void glTexCoord( const GLshort s )
{
	glTexCoord1s(s);
}

	/// wrapper for glTexCoord 2 dimensions (double) 
inline void glTexCoord( const GLdouble s, const GLdouble t )
{
	glTexCoord2d(s,t);
}

	/// wrapper for glTexCoord 2 dimensions (float)
inline void glTexCoord( const GLfloat s, const GLfloat t )
{
	glTexCoord2f(s,t);
}

	/// wrapper for glTexCoord 2 dimensions (int) 
inline void glTexCoord( const GLint s, const GLint t )
{
	glTexCoord2i(s,t);
}

	/// wrapper for glTexCoord 2 dimensions (short) 
inline void glTexCoord( const GLshort s, const GLshort t )
{
	glTexCoord2s(s,t);
}

	/// wrapper for glTexCoord 3 dimensions (double)
inline void glTexCoord( const GLdouble s, const GLdouble t, const GLdouble r )
{
	glTexCoord3d(s,t,r);
}

	/// wrapper for glTexCoord 3 dimensions (float)
inline void glTexCoord( const GLfloat s, const GLfloat t, const GLfloat r )
{
	glTexCoord3f(s,t,r);
}

	/// wrapper for glTexCoord 3 dimensions (int)
inline void glTexCoord( const GLint s, const GLint t, const GLint r )
{
	glTexCoord3i(s,t,r);
}

	/// wrapper for glTexCoord 3 dimensions (short)
inline void glTexCoord( const GLshort s, const GLshort t, const GLshort r )
{
	glTexCoord3s(s,t,r);
}

	/// wrapper for glTexCoord 4 dimensions (double) 
inline void glTexCoord( const GLdouble s, const GLdouble t, const GLdouble r, const GLdouble q )
{
	glTexCoord4d(s,t,r,q);
}

	/// wrapper for glTexCoord 4 dimensions (float) 
inline void glTexCoord( const GLfloat s, const GLfloat t, const GLfloat r, const GLfloat q )
{
	glTexCoord4f(s,t,r,q);
}

	/// wrapper for glTexCoord 4 dimensions (int) 
inline void glTexCoord( const GLint s, const GLint t, const GLint r, const GLint q )
{
	glTexCoord4i(s,t,r,q);
}

	/// wrapper for glTexCoord 4 dimensions (short) 
inline void glTexCoord( const GLshort s, const GLshort t, const GLshort r, const GLshort q )
{
	glTexCoord4s(s,t,r,q);
}

	/// wrapper for glTexCoord 1 dimension (double pointer) 
inline void glTexCoord1( const GLdouble * const v )
{
	glTexCoord1dv(v);
}

	/// wrapper for glTexCoord 1 dimension (float pointer) 
inline void glTexCoord1( const GLfloat * const v )
{
	glTexCoord1fv(v);
}

	/// wrapper for glTexCoord 1 dimension (int pointer) 
inline void glTexCoord1( const GLint * const v )
{
	glTexCoord1iv(v);
}

	/// wrapper for glTexCoord 1 dimension (short pointer) 
inline void glTexCoord1( const GLshort * const v )
{
	glTexCoord1sv(v);
}

	/// wrapper for glTexCoord 2 dimensions (double pointer) 
inline void glTexCoord2( const GLdouble * const v )
{
	glTexCoord2dv(v);
}

	/// wrapper for glTexCoord 2 dimensions (float pointer)  
inline void glTexCoord2( const GLfloat * const v )
{
	glTexCoord2fv(v);
}

	/// wrapper for glTexCoord 2 dimensions (int pointer)  
inline void glTexCoord2( const GLint * const v )
{
	glTexCoord2iv(v);
}

	/// wrapper for glTexCoord 2 dimensions (short pointer)  
inline void glTexCoord2( const GLshort * const v )
{
	glTexCoord2sv(v);
}

	/// wrapper for glTexCoord 3 dimensions (double pointer) 
inline void glTexCoord3( const GLdouble * const v )
{
	glTexCoord3dv(v);
}

	/// wrapper for glTexCoord 3 dimensions (float pointer)  
inline void glTexCoord3( const GLfloat * const v )
{
	glTexCoord3fv(v);
}

	/// wrapper for glTexCoord 3 dimensions (int pointer)  
inline void glTexCoord3( const GLint * const v )
{
	glTexCoord3iv(v);
}

	/// wrapper for glTexCoord 3 dimensions (short pointer)  
inline void glTexCoord3( const GLshort * const v )
{
	glTexCoord3sv(v);
}

	/// wrapper for glTexCoord 4 dimensions (double pointer) 
inline void glTexCoord4( const GLdouble * const v )
{
	glTexCoord4dv(v);
}

	/// wrapper for glTexCoord 4 dimensions (float pointer)  
inline void glTexCoord4( const GLfloat * const v )
{
	glTexCoord4fv(v);
}

	/// wrapper for glTexCoord 4 dimensions (int pointer)  
inline void glTexCoord4( const GLint * const v )
{
	glTexCoord4iv(v);
}

	/// wrapper for glTexCoord 4 dimensions (short pointer) 
inline void glTexCoord4( const GLshort * const v )
{
	glTexCoord4sv(v);
}

//@}

/** @name glTexEnv Wrapper
 */

//@{

	/// wrapper for glTexEnv (float)
inline void glTexEnv( const GLenum target, const GLenum pname, const GLfloat param )
{
	glTexEnvf(target,pname,param);
}

	/// wrapper for glTexEnv (int) 
inline void glTexEnv( const GLenum target, const GLenum pname, const GLint param )
{
	glTexEnvi(target,pname,param);
}
 
	/// wrapper for glTexEnv (float pointer)
inline void glTexEnv( const GLenum target, const GLenum pname, const GLfloat * const params )
{
	glTexEnvfv(target,pname,params);
}

	/// wrapper for glTexEnv (int pointer)
inline void glTexEnv( const GLenum target, const GLenum pname, const GLint * const params )
{
	glTexEnviv(target,pname,params);
}

//@}

/** @name glTexGen Wrapper
 */

//@{

	/// wrapper for glTexGen (double)
inline void glTexGen( const GLenum coord, const GLenum pname, const GLdouble param )
{
	glTexGend(coord,pname,param);
}

	/// wrapper for glTexGen (float) 
inline void glTexGen( const GLenum coord, const GLenum pname, const GLfloat param )
{
	glTexGenf(coord,pname,param);
}

	/// wrapper for glTexGen (int) 
inline void glTexGen( const GLenum coord, const GLenum pname, const GLint param )
{
	glTexGeni(coord,pname,param);
}

	/// wrapper for glTexGen (double pointer) 
inline void glTexGen( const GLenum coord, const GLenum pname, const GLdouble * const params )
{
	glTexGendv(coord,pname,params);
}

	/// wrapper for glTexGen (float pointer) 
inline void glTexGen( const GLenum coord, const GLenum pname, const GLfloat * const params )
{
	glTexGenfv(coord,pname,params);
}

	/// wrapper for glTexGen (int pointer) 
inline void glTexGen( const GLenum coord, const GLenum pname, const GLint * const params )
{	 
	glTexGeniv(coord,pname,params);
}

//@}

/** @name glTexParameter Wrapper
 */

//@{

	/// wrapper for glTexParameter (float)
inline void glTexParameter( const GLenum target, const GLenum pname, const GLfloat param )
{
	glTexParameterf(target,pname,param);
}

	/// wrapper for glTexParameter (int) 
inline void glTexParameter( const GLenum target, const GLenum pname, const GLint param )
{
	glTexParameteri(target,pname,param);
}

	/// wrapper for glTexParameter (int pointer)
inline void glTexParameter( const GLenum target, const GLenum pname, const GLint * const params )
{
	glTexParameteriv(target,pname,params);
}

	/// wrapper for glTexParameter (float pointer )
inline void glTexParameter( const GLenum target, const GLenum pname, const GLfloat * const params )
{
	glTexParameterfv(target,pname,params);
}

//@}

/** @name glTranslate Wrapper
 */

//@{

	/// wrapper for glTranslate (double)
inline void glTranslate( const GLdouble x, const GLdouble y, const GLdouble z )
{
	glTranslated(x,y,z);
}

	/// wrapper for glTranslate (float) 
inline void glTranslate( const GLfloat x, const GLfloat y, const GLfloat z )
{
	glTranslatef(x,y,z);
}

//@}

/** @name glVertex Wrapper
 */

//@{

	/// wrapper for glVertex 2 dimensions (double)
inline void glVertex( const GLdouble x, const GLdouble y )
{
	glVertex2d(x,y);
}

	/// wrapper for glVertex 2 dimensions (float) 
inline void glVertex( const GLfloat x, const GLfloat y )
{
	glVertex2f(x,y);
}

	/// wrapper for glVertex 2 dimensions (int) 
inline void glVertex( const GLint x, const GLint y )
{
	glVertex2i(x,y);
}

	/// wrapper for glVertex 2 dimensions (short) 
inline void glVertex(const GLshort x, const GLshort y )
{
	glVertex2s(x,y);
}
 
	/// wrapper for glVertex 3 dimensions (double) 
inline void glVertex( const GLdouble x, const GLdouble y, const GLdouble z )
{
	glVertex3d(x,y,z);
}
 
	/// wrapper for glVertex 3 dimensions (float) 
inline void glVertex( const GLfloat x, const GLfloat y, const GLfloat z )
{
	glVertex3f(x,y,z);
}
 
	/// wrapper for glVertex 3 dimensions (int) 
inline void glVertex( const GLint x, const GLint y, const GLint z )
{
    glVertex3i(x,y,z);
}
 
	/// wrapper for glVertex 3 dimensions (short) 
inline void glVertex( const GLshort x, const GLshort y, const GLshort z )
{
	glVertex3s(x,y,z);	
}

	/// wrapper for glVertex 4 dimensions (double) 
inline void glVertex( const GLdouble x, const GLdouble y, const GLdouble z, const GLdouble w )
{
	glVertex4d(x,y,z,w);
}
 
	/// wrapper for glVertex 4 dimensions (float) 
inline void glVertex( const GLfloat x, const GLfloat y, const GLfloat z, const GLfloat w )
{
	glVertex4f(x,y,z,w);
}

	/// wrapper for glVertex 4 dimensions (int)  
inline void glVertex( const GLint x, const GLint y, const GLint z, const GLint w )
{
	glVertex4i(x,y,z,w);
}

	/// wrapper for glVertex 4 dimensions (short)  
inline void glVertex( const GLshort x, const GLshort y, const GLshort z, const GLshort w )
{
	glVertex4s(x,y,z,w);
}

 	/// wrapper for glVertex 2 dimensions (double pointer) 
inline void glVertex2( const GLdouble * const v )
{
	glVertex2dv(v);
}

 	/// wrapper for glVertex 2 dimensions (float pointer)  
inline void glVertex2( const GLfloat * const v )
{
	glVertex2fv(v);
}

 	/// wrapper for glVertex 2 dimensions (int pointer) 
inline void glVertex2( const GLint * const v )
{
	glVertex2iv(v);
}

 	/// wrapper for glVertex 2 dimensions (short pointer)  
inline void glVertex2( const GLshort * const v )
{
	glVertex2sv(v);
}

 	/// wrapper for glVertex 3 dimensions (double pointer)  
inline void glVertex3( const GLdouble * const v )
{
	glVertex3dv(v);
}

 	/// wrapper for glVertex 3 dimensions (float pointer)   
inline void glVertex3( const GLfloat * const v )
{
	glVertex3fv(v);
}

 	/// wrapper for glVertex 3 dimensions (int pointer)   
inline void glVertex3( const GLint * const v )
{
	glVertex3iv(v);
}

 	/// wrapper for glVertex 3 dimensions (short pointer)   
inline void glVertex3( const GLshort * const v )
{
	glVertex3sv(v);
}
 
 	/// wrapper for glVertex 4 dimensions (double pointer)   
inline void glVertex4( const GLdouble * const v )
{
	glVertex4dv(v);
}

 	/// wrapper for glVertex 4 dimensions (float pointer)    
inline void glVertex4( const GLfloat * const v	)
{
	glVertex4fv(v);
}

 	/// wrapper for glVertex 4 dimensions (int pointer)    
inline void glVertex4( const GLint * const v )
{
	glVertex4iv(v);
}

 	/// wrapper for glVertex 4 dimensions (short pointer)    
inline void glVertex4( const GLshort * const v	)
{
	glVertex4sv(v);
}

//@}

//@}

#endif
