
/*****************************************************************************
 * gcrLib : Graphics Rocchini's Library V0.9 (the nth OpenGL wrapper)        *
 *					                                                         *
 * Copyright(C) 1999 by Claudio Rocchini. All rights reserved.               *
 *					                                                         *
 * Permission  to use, copy, modify, distribute  and sell this  software and *
 * its documentation for any purpose is hereby granted without fee, provided *
 * that  the above copyright notice appear  in all copies and that both that *
 * copyright   notice  and  this  permission  notice  appear  in  supporting *
 * documentation. the author makes  no representations about the suitability *
 * of this software for any purpose. It is provided  "as is" without express *
 * or implied warranty.                                                      *
 *					                                                         *
 *****************************************************************************/


#ifndef GR_SHQN_COLOR
#define GR_SHQN_COLOR


class grColor
{
public:
};


class grColor3b : public grColor
{
public:
	GLbyte color[3];
};


class grColor3d : public grColor
{
public:
	GLdouble color[3];
};


class grColor3f : public grColor
{
public:
	inline grColor3f( void ) {}
	inline grColor3f( const GLfloat r, const GLfloat g, const GLfloat b );
	inline void Set( const GLfloat r, const GLfloat g, const GLfloat b );
	inline GLfloat & grColor3f::operator [] ( const int i );
	inline int operator < ( const grColor3f & c ) const;
	inline int operator == ( const grColor3f & c ) const;

	GLfloat color[3];
};


inline grColor3f::grColor3f( const GLfloat r, const GLfloat g, const GLfloat b )
{
	color[0] = r;
	color[1] = g;
	color[2] = b;
}


inline void grColor3f::Set( const GLfloat r, const GLfloat g, const GLfloat b )
{
	color[0] = r;
	color[1] = g;
	color[2] = b;
}


inline GLfloat & grColor3f::operator [] ( const int i )
{
	return color[i];
}


inline int grColor3f::operator < ( const grColor3f & c ) const
{
	return color[0]<c.color[0];
}


inline int grColor3f::operator == ( const grColor3f & c ) const
{
	return color[0]==c.color[0] &&
		   color[1]==c.color[1] &&
		   color[2]==c.color[2] ;
}


class grColor3i : public grColor
{
public:
	GLint color[3];
};


class grColor3s : public grColor
{
public:
	GLshort color[3];
};


class grColor3ub : public grColor
{
public:
	GLubyte color[3];
};


class grColor3ui : public grColor
{
public:
	GLuint color[3];
};


class grColor3us : public grColor
{
public:
	GLushort color[3];
};


class grColor4b : public grColor
{
public:
	GLbyte color[4];
};


class grColor4d : public grColor
{
public:
	GLdouble color[4];
};


class grColor4f : public grColor
{
public:
	inline grColor4f( void ) {}
	inline grColor4f( const GLfloat r, const GLfloat g, const GLfloat b, const GLfloat a );
	inline void Set( const GLfloat r, const GLfloat g, const GLfloat b, const GLfloat a );
	inline GLfloat & operator [] ( const int i );
	inline const GLfloat & operator [] ( const int i ) const;
	inline int operator < ( const grColor4f & c ) const;
	inline int operator == ( const grColor4f & c ) const;

	GLfloat color[4];
};


inline grColor4f::grColor4f( const GLfloat r, const GLfloat g, const GLfloat b, const GLfloat a )
{
	color[0] = r;
	color[1] = g;
	color[2] = b;
	color[3] = a;
}


inline void grColor4f::Set( const GLfloat r, const GLfloat g, const GLfloat b, const GLfloat a )
{
	color[0] = r;
	color[1] = g;
	color[2] = b;
	color[3] = a;
}


inline GLfloat & grColor4f::operator [] ( const int i )
{
	return color[i];
}


inline const GLfloat & grColor4f::operator [] ( const int i ) const 
{
	return color[i];
}

inline int grColor4f::operator < ( const grColor4f & c ) const
{
	return color[0]<c.color[0];
}


inline int grColor4f::operator == ( const grColor4f & c ) const
{
	return color[0]==c.color[0] &&
		   color[1]==c.color[1] &&
		   color[2]==c.color[2] &&
		   color[3]==c.color[3] ;
}


class grColor4i : public grColor
{
public:
	GLint color[4];
};


class grColor4s : public grColor
{
public:
	GLshort color[4];
};


class grColor4ub : public grColor
{
public:
	GLubyte color[4];
};


class grColor4ui : public grColor
{
public:
	GLuint color[4];
};


class grColor4us : public grColor
{
public:
	GLushort color[4];
};


#endif