

/*****************************************************************************
 * gcrLib : Graphics Rocchini's Library V1.0 (the nth OpenGL wrapper)        *
 *					                                                         *
 * Copyright(C) 1999 by Claudio Rocchini. All rights reserved.               *
 *					                                                         *
 * Permission  to use, copy, modify, distribute  and sell this  software and *
 * its documentation for any purpose is hereby granted without fee, provided *
 * that  the above copyright notice appear  in all copies and that both that *
 * copyright   notice  and  this  permission  notice  appear  in  supporting *
 * documentation. the author makes  no representations about the suitability *
 * of this software for any purpose. It is provided  "as is" without express *
 * or implied warranty.                                                      *
 *					                                                         *
 *****************************************************************************/

#pragma warning( disable : 4804 )

#include <windows.h>
#include <gl/gl.h>
#include <gl/glu.h>
#include <assert.h>


#include "material.h"



const char * grSingleMaterial::name = "SingleMaterial";
const char * grMaterial::name = "Material";


const char * grSingleMaterial::Name() const
{
	return name;
}


void grSingleMaterial::Render( grStatus & /*status*/ )
{
	GL();
}


const char * grMaterial::Name() const
{
	return name;
}


void grMaterial::Render( grStatus & status )
{
	status.material = this;
}

void grMaterial::GL( const int i ) const
{
	if(i==0)
	{
		glMaterialf(face,GL_SHININESS,shininess[0]);
		glMaterialfv(face,GL_AMBIENT,ambient[0].color);
		glMaterialfv(face,GL_DIFFUSE,diffuse[0].color);
		glMaterialfv(face,GL_SPECULAR,specular[0].color);
		glMaterialfv(face,GL_EMISSION,emission[0].color);
	}
	else
	{
		if(shininess.size()>1)
			glMaterialf(face,GL_SHININESS,shininess[i]);
		if(ambient.size()>1)
			glMaterialfv(face,GL_AMBIENT,ambient[i].color);
		if(diffuse.size()>1)
			glMaterialfv(face,GL_DIFFUSE,diffuse[i].color);
		if(specular.size()>1)
			glMaterialfv(face,GL_SPECULAR,specular[i].color);
		if(emission.size()>1)
			glMaterialfv(face,GL_EMISSION,emission[i].color);
	}
}
