
/*****************************************************************************
 * gcrLib : Graphics Rocchini's Library V0.9 (the nth OpenGL wrapper)        *
 *					                                                         *
 * Copyright(C) 1999 by Claudio Rocchini. All rights reserved.               *
 *					                                                         *
 * Permission  to use, copy, modify, distribute  and sell this  software and *
 * its documentation for any purpose is hereby granted without fee, provided *
 * that  the above copyright notice appear  in all copies and that both that *
 * copyright   notice  and  this  permission  notice  appear  in  supporting *
 * documentation. the author makes  no representations about the suitability *
 * of this software for any purpose. It is provided  "as is" without express *
 * or implied warranty.                                                      *
 *					                                                         *
 *****************************************************************************/


#ifndef GR_SHQN_MATERIALBINDING
#define GR_SHQN_MATERIALBINDING


#include "node.h"
#include "status.h"

	/** Material binding.
	    This node specifies the current material binding.
		The values are: PER_VERTEX (a material for each vertex), OVERALL
		(a material for all objects), PER_FACE (a material for
		each face), PER_CORNER (a material for each vertex in a face),
		PER_PART (a material for each group of ojects, ie strip, lineset, ...).
		@see grMaterial.
	 */
class grMaterialBinding : public grNode
{
public:
	enum { PER_VERTEX=0, OVERALL, PER_FACE, PER_CORNER, PER_PART };
		/// Default constructor
	inline grMaterialBinding( void );
		/// see grNode
	const char * Name( void ) const;
	void Render( grStatus & status );
		/// The binding mode.
	int value;

private:
	static const char * name;
};


inline grMaterialBinding::grMaterialBinding( void )
{
	value = PER_VERTEX;
}



#endif
