
/*****************************************************************************
 * gcrLib : Graphics Rocchini's Library V1.0 (the nth OpenGL wrapper)        *
 *					                                                         *
 * Copyright(C) 1999 by Claudio Rocchini. All rights reserved.               *
 *					                                                         *
 * Permission  to use, copy, modify, distribute  and sell this  software and *
 * its documentation for any purpose is hereby granted without fee, provided *
 * that  the above copyright notice appear  in all copies and that both that *
 * copyright   notice  and  this  permission  notice  appear  in  supporting *
 * documentation. the author makes  no representations about the suitability *
 * of this software for any purpose. It is provided  "as is" without express *
 * or implied warranty.                                                      *
 *					                                                         *
 *****************************************************************************/

#pragma warning( disable : 4514 4201 4804 )

#include <windows.h>
#include <gl/gl.h>
#include <gl/glu.h>
#include <assert.h>


#include "normal.h"



const char * grNormald::name ="Normald";
const char * grNormalf::name ="Normalf";
const char * grNormali::name ="Normali";
const char * grNormals::name ="Normals";


void grNormal::Render( grStatus & status )
{
	status.normal = this;
}


const char * grNormald::Name() const
{
	return name;
}


int grNormald::Size() const
{
	return vector<Coord3d>::size();
}


void grNormald::GL( const int i ) const
{
	glNormal((*this)[i].x,(*this)[i].y,(*this)[i].z);
}


const char * grNormalf::Name() const
{
	return name;
}


int grNormalf::Size() const
{
	return vector<Coord3f>::size();
}


void grNormalf::GL( const int i ) const
{
	glNormal((*this)[i].x,(*this)[i].y,(*this)[i].z);
}


const char * grNormali::Name() const
{
	return name;
}


int grNormali::Size() const
{
	return vector<Coord3i>::size();
}


void grNormali::GL( const int i ) const
{
	glNormal((*this)[i].x,(*this)[i].y,(*this)[i].z);
}


const char * grNormals::Name() const
{
	return name;
}


int grNormals::Size() const
{
	return vector<Coord3s>::size();
}


void grNormals::GL( const int i ) const
{
	glNormal((*this)[i].x,(*this)[i].y,(*this)[i].z);
}


