
/*****************************************************************************
 * gcrLib : Graphics Rocchini's Library V1   (the nth OpenGL wrapper)        *
 *					                                                         *
 * Copyright(C) 1999 by Claudio Rocchini. All rights reserved.               *
 *					                                                         *
 * Permission  to use, copy, modify, distribute  and sell this  software and *
 * its documentation for any purpose is hereby granted without fee, provided *
 * that  the above copyright notice appear  in all copies and that both that *
 * copyright   notice  and  this  permission  notice  appear  in  supporting *
 * documentation. the author makes  no representations about the suitability *
 * of this software for any purpose. It is provided  "as is" without express *
 * or implied warranty.                                                      *
 *					                                                         *
 *****************************************************************************/


#ifndef GR_SHQN_STATUS
#define GR_SHQN_STATUS


class grVertex;
class grNormal;
class grMaterial;
class grTexCoord;
class grNode;

	/** Traversal status description.
	    This node represents the traversal status during rendering,
		selection, or other traversal functions.
	    @see grRender, grNode, grTree, grTMesh.
	 */
class grStatus
{
public:
		/// Default constructor
	inline grStatus();
		/// Reset the traversal status to default value
	inline void Reset();

		/// Current vertex specification
	grVertex   * vertex;
		/// Current normal specification
	grNormal   * normal;
		/// Current material specification
	grMaterial * material;
		/// Current set of texture coordinates 
	grTexCoord * texcoord;
		/// Current normal binding mode
	int          nbinding;
		/// Current material binding mode
	int          mbinding;
		/// Current texture coordinates binding mode
	int			 tcbinding;
		/// Current triangle mesh visualization mode (see grTMesh)
	int          tmvmode;

	grNode     * onesel;		// se !=0 selezion di elemento su onesel
	static GLuint lastname;		// Prossimo nome libero
};


inline grStatus::grStatus()
{
	Reset();
}


inline void grStatus::Reset()
{
	vertex	  = 0;
	normal	  = 0;
	material  = 0;
	texcoord  = 0;
	nbinding  = 0;
	mbinding  = 0;
	tcbinding = 0;
	onesel    = 0;
	tmvmode   = 0;
}


#endif