

/*****************************************************************************
 * gcrLib : Graphics Rocchini's Library V1.0 (the nth OpenGL wrapper)        *
 *					                                                         *
 * Copyright(C) 1999 by Claudio Rocchini. All rights reserved.               *
 *					                                                         *
 * Permission  to use, copy, modify, distribute  and sell this  software and *
 * its documentation for any purpose is hereby granted without fee, provided *
 * that  the above copyright notice appear  in all copies and that both that *
 * copyright   notice  and  this  permission  notice  appear  in  supporting *
 * documentation. the author makes  no representations about the suitability *
 * of this software for any purpose. It is provided  "as is" without express *
 * or implied warranty.                                                      *
 *					                                                         *
 *****************************************************************************/


#ifndef GR_SHQN_SWITCH
#define GR_SHQN_SWITCH


#include "tree.h"

	/** Activable/deactivable node.
	    This node is a activable/deactivable grTree.
		@see grTree, grNode.
	 */
class grSwitch : public grTree
{
		/// Default constructor
	inline grSwitch();
		/// see grNode
	const char * Name( void ) const;
	void Render( grStatus & status );
	void Select( grStatus & status );
		/// The node is active if this field is true.
	bool active;

public:
	private:
	static const char * name;
};

inline grSwitch::grSwitch()
{
	active = true;
}

#endif