
/*****************************************************************************
 * gcrLib : Graphics Rocchini's Library V1.0 (the nth OpenGL wrapper)        *
 *					                                                         *
 * Copyright(C) 1999 by Claudio Rocchini. All rights reserved.               *
 *					                                                         *
 * Permission  to use, copy, modify, distribute  and sell this  software and *
 * its documentation for any purpose is hereby granted without fee, provided *
 * that  the above copyright notice appear  in all copies and that both that *
 * copyright   notice  and  this  permission  notice  appear  in  supporting *
 * documentation. the author makes  no representations about the suitability *
 * of this software for any purpose. It is provided  "as is" without express *
 * or implied warranty.                                                      *
 *					                                                         *
 *****************************************************************************/


#ifndef GR_SHQN_TEXCOORDBINDING
#define GR_SHQN_TEXCOORDBINDING



#include "node.h"
#include "status.h"


	/** Texture coordinates binding.
	    This node specifies the current texture coordinate binding.
		The values are: PER_VERTEX (a coordinate for each vertex), OVERALL
		(a coordinate for all objects), PER_FACE (a coordinate for
		each face), PER_CORNER (a coordinate for each vertex in a face),
		PER_PART (a coordinate for each group of ojects, ie strip, lineset, ...).
		@see grTexCoord.
	 */
class grTexCoordBinding : public grNode
{
public:
	enum { PER_VERTEX=0, OVERALL, PER_FACE, PER_CORNER, PER_PART };
		/// Default constructor
	inline grTexCoordBinding();
		/// see grNode
	const char * Name() const;
	void Render( grStatus & status );
		/// The binding mode.
	int value;

private:
	static const char * name;
};


inline grTexCoordBinding::grTexCoordBinding()
{
	value = PER_VERTEX;
}


#endif