
/*****************************************************************************
 * gcrLib : Graphics Rocchini's Library V0.9 (the nth OpenGL wrapper)        *
 *					                                                         *
 * Copyright(C) 1999 by Claudio Rocchini. All rights reserved.               *
 *					                                                         *
 * Permission  to use, copy, modify, distribute  and sell this  software and *
 * its documentation for any purpose is hereby granted without fee, provided *
 * that  the above copyright notice appear  in all copies and that both that *
 * copyright   notice  and  this  permission  notice  appear  in  supporting *
 * documentation. the author makes  no representations about the suitability *
 * of this software for any purpose. It is provided  "as is" without express *
 * or implied warranty.                                                      *
 *					                                                         *
 *****************************************************************************/


#ifndef GR_SHQN_XSTREAM
#define GR_SHQN_XSTREAM


class XStream
{
public:
	FILE * fp;

	inline XStream & operator << ( const float f );
	inline XStream & operator << ( const double d );
	inline XStream & operator << ( const int i );
	inline XStream & operator << ( const short s );
	inline XStream & operator << ( const char c );
	inline XStream & operator << ( const unsigned int ui );
	inline XStream & operator << ( const unsigned short us );
	inline XStream & operator << ( const unsigned char uc );
	inline XStream & operator << ( const char * str );

	inline XStream & operator >> ( float & f );
	inline XStream & operator >> ( double & d );
	inline XStream & operator >> ( int & i );
	inline XStream & operator >> ( short & s );
	inline XStream & operator >> ( char & c );
	inline XStream & operator >> ( unsigned int & ui );
	inline XStream & operator >> ( unsigned short & us );
	inline XStream & operator >> ( unsigned char & uc );
	//inline XStream & operator >> ( char * str );
};



inline XStream & XStream::operator << ( const float f )
{
	fprintf(fp,"%g",f);
	return *this;
}


inline XStream & XStream::operator << ( const double d )
{
	fprintf(fp,"%g",d);
	return *this;
}


inline XStream & XStream::operator << ( const int i )
{
	fprintf(fp,"%d",i);
	return *this;
}


inline XStream & XStream::operator << ( const short s )
{
	fprintf(fp,"%d",s);
	return *this;
}


inline XStream & XStream::operator << ( const char c )
{
	fprintf(fp,"%d",c);
	return *this;
}


inline XStream & XStream::operator << ( const unsigned int ui )
{
	fprintf(fp,"%u",ui);
	return *this;
}


inline XStream & XStream::operator << ( const unsigned short us )
{
	fprintf(fp,"%u",us);
	return *this;
}


inline XStream & XStream::operator << ( const unsigned char uc )
{
	fprintf(fp,"%u",uc);
	return *this;
}


inline XStream & XStream::operator << ( const char * str )
{
	fprintf(fp,"%s",str);
	return *this;
}




inline XStream & XStream::operator >> ( float & f )
{
	fscanf(fp,"%f",&f);
	return *this;
}


inline XStream & XStream::operator >> ( double & d )
{
	float t;
	fscanf(fp,"%f",&t);
	d = t;
	return *this;
}


inline XStream & XStream::operator >> ( int & i )
{
	fscanf(fp,"%d",&i);
	return *this;
}


inline XStream & XStream::operator >> ( short & s )
{
	int t;
	fscanf(fp,"%d",&t);
	s = int(t);
	return *this;
}


inline XStream & XStream::operator >> ( char & c )
{
	return *this;
}


inline XStream & XStream::operator >> ( unsigned int & ui )
{
	fscanf(fp,"%u",&ui);
	return *this;
}


inline XStream & XStream::operator >> ( unsigned short & us )
{
	unsigned int t;
	fscanf(fp,"%d",&t);
	us = (unsigned short)t;
	return *this;
}


inline XStream & XStream::operator >> ( unsigned char & uc )
{
	unsigned int t;
	fscanf(fp,"%d",&t);
	us = (unsigned char)t;
	return *this;
}



#endif

